module BNFC.Backend.Agda.Test where

import BNFC.CF
import BNFC.Options.GlobalOptions
import BNFC.Prelude

import BNFC.Backend.Agda.Options
import BNFC.Backend.Agda.State
import BNFC.Backend.CommonInterface.Backend

import BNFC.Backend.Haskell.Options (TokenText (..))
import BNFC.Backend.Haskell.Test (cf2test)
import BNFC.Backend.Haskell.Utilities.Utils

import Control.Monad.State

import System.FilePath ( takeBaseName )

agdaParserTest :: LBNF -> State AgdaBackendState Result
agdaParserTest lbnf = do
  st <- get
  let
    cfName      = takeBaseName $ optInput $ globalOpt st
    inDirectory = inDir $ agdaOpts st
    nSpace      = nameSpace $ agdaOpts st
    test        = cf2test lbnf cfName TextToken inDirectory nSpace
  return [(mkFilePath inDirectory nSpace cfName "Test" "hs", test)]
