{-# LANGUAGE CPP #-}
{-# LANGUAGE DataKinds #-}
{-# LANGUAGE TypeFamilies #-}

module BNFC.Backend.CPP where

import BNFC.Prelude

import Control.Monad.Except
import Control.Monad.State
#if !MIN_VERSION_base(4,13,0)
import Control.Applicative ((<*>))
#endif
import Options.Applicative

import BNFC.CF

import BNFC.Options.GlobalOptions
import BNFC.Options.Target

import BNFC.Backend.CommonInterface.Backend

instance Backend 'TargetCpp where
  type BackendOptions 'TargetCpp = CppBackendOptions
  type BackendState 'TargetCpp = CppBackendState
  parseOpts :: Parser CppBackendOptions
  parseOpts = undefined
  initState  :: LBNF -> GlobalOptions -> BackendOptions 'TargetCpp -> Except String (BackendState 'TargetCpp)
  initState = undefined
  abstractSyntax :: LBNF -> State (BackendState 'TargetCpp) Result
  abstractSyntax = undefined
  printer :: LBNF -> State (BackendState 'TargetCpp) Result
  printer = undefined
  lexer :: LBNF -> State (BackendState 'TargetCpp) Result
  lexer = undefined
  parser :: LBNF -> State (BackendState 'TargetCpp) Result
  parser = undefined
  parserTest :: LBNF -> State (BackendState 'TargetCpp) Result
  parserTest = undefined
  makefile :: LBNF -> State (BackendState 'TargetCpp) Result
  makefile = undefined

data CppBackendOptions = CppOpts
  { lineNumbers :: Bool
  , nameSpace   :: Maybe String
  }

cppOptionsParser :: Parser CppBackendOptions
cppOptionsParser = CppOpts <$> oLineNumbers <*> oNameSpace

  where

    -- line-numbers option
    oLineNumbers =
      switch
          ( short 'l'
         <> long "line-numbers"
         <> help "Add and set line_number field for all syntax classes" )

    -- name-space option
    oNameSpace =
      optional $
      strOption
          ( short 'p'
         <> long "name-space"
         <> help "Prepend NAMESPACE to the package/module name"
         <> metavar "NAMESPACE")

data CppBackendState
