-- | Info options.

module BNFC.Options.InfoOptions where

import BNFC.Prelude

import BNFC.License

import BNFC.Options.Version

import Options.Applicative


-- info options

self :: String
self = "bnfc"

versionOption :: Parser (a -> a)
versionOption =
  infoOption (unwords versionWords)
    $  long "version"
    <> help "Show version info."

versionWords :: [String]
versionWords = [ self, "version", version ]

numericVersionOption :: Parser (a -> a)
numericVersionOption =
  infoOption version
    $  long "numeric-version"
    <> help "Show just version number."

licenseOption :: Parser (a -> a)
licenseOption =
  infoOption license
    $  long "license"
    <> help (unwords ["Show", self, "license text."])
