module BNFC.Options.Target where

import BNFC.Prelude

----------------------------------------------------------------------------

-- | Target languages
data TargetLanguage =
  TargetAgda | TargetC | TargetCpp | TargetCppNoStl
  | TargetHaskell | TargetLatex
  | TargetJava | TargetOCaml | TargetPygments
  | TargetTxt2Tags | TargetCheck
  deriving (Eq, Bounded, Enum, Ord)

instance Show TargetLanguage where
  show TargetAgda        = "Agda"
  show TargetC           = "C"
  show TargetCpp         = "C++"
  show TargetCppNoStl    = "C++ (without STL)"
  show TargetHaskell     = "Haskell"
  show TargetLatex       = "Latex"
  show TargetJava        = "Java"
  show TargetOCaml       = "OCaml"
  show TargetPygments    = "Pygments"
  show TargetTxt2Tags    = "Txt2Tags"
  show TargetCheck       = "Check LBNF file"
