{-# LANGUAGE NoImplicitPrelude #-}

module Main where

import BNFC.Prelude

import Test.Tasty
import Test.Tasty.Silver

import BNFC.Main   (runBnfcArgs)
import Paths_BNFC3 (getDataDir)

import Data.Text (pack)

import System.FilePath ((</>), (<.>))

main :: IO ()
main = do
  dir <- getDataDir
  defaultMain (t2tFile dir)

t2tFile :: FilePath -> TestTree
t2tFile dir = testGroup "Latex" $ map (checkT2TFile dir) examples

checkT2TFile :: FilePath -> (String, String) -> TestTree
checkT2TFile dir (testName, testPath) =
  goldenVsAction testName golden action pack
  where
    golden :: FilePath
    golden = dir </> "test/txt2tags/t2t" </> testName <.> "golden"
    action :: IO String
    action = do
      let filename = dir </> "examples" </> testPath <.> "cf"
      ((Just result, _), _) <- runBnfcArgs [ filename, "txt2tags" ]
      let (Just file) = lookup (testName <.> "t2t") result
      return file

examples :: [(String, String)]
examples =
  [ ("Alfa", "Alfa/Alfa")
  , ("C", "C/C")
  , ("C4", "C/C4")
  , ("Calc", "Calc/Calc")
  , ("GF", "GF/GF")
  , ("Java", "Java/Java")
  , ("JavaletteLight", "Javalette/JavaletteLight")
  , ("LBNF", "LBNF/LBNF")
  , ("OCL", "OCL/OCL")
  , ("Cpp", "Cpp/Cpp")
  , ("Cubicaltt", "Cubicaltt/Cubicaltt")
  , ("FstStudio", "FstStudio/FstStudio")
  , ("Core", "Haskell-core/Core")
  , ("Prolog", "Prolog/Prolog")
  ]
